package dashboard

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/operation/src/dashboard/model"
	"shylinux.com/x/operation/src/operation"
)

type Table struct {
	operation.Table
	list string `name:"list client_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.USER_CLIENT_ROLE:
		s.InputsListRole(m, UserClientRoleList, arg...)
	case model.CLIENT_TYPE:
		s.InputsList(m, ClientTypeList, arg...)
	case web.SPACE:
		s.Hash.Inputs(m, arg...)
	case ctx.INDEX:
		s.Hash.Inputs(m, arg...)
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		switch key {
		case model.USER_CLIENT_ROLE:
			value = UserClientRole(kit.Int(value)).String()
		case model.CLIENT_TYPE:
			value = ClientType(kit.Int(value)).String()
		}
		return value
	})
	return s.Table.RewriteAppend(m)
}

type Tables struct{ Table }

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}
