package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID              = "uid"
	NAME             = "name"
	TYPE             = "type"
	ROLE             = "role"
	TITLE            = "title"
	CONTENT          = "content"
	CREATED_AT       = "created_at"
	USER_UID         = "user_uid"
	USER_CLIENT_ROLE = "user_client_role"
	CLIENT_UID       = "client_uid"
	CLIENT_NAME      = "client_name"
	CLIENT_TYPE      = "client_type"
	SUMMARY_UID      = "summary_uid"
	COMPANY_UID      = "company_uid"
	CITY_UID         = "city_uid"
	HOST             = "host"
	PORT             = "port"
	USERNAME         = "username"
	PASSWORD         = "password"
	DATABASE         = "database"
	TABLES           = "tables"
	FIELDS           = "fields"
	QUERY            = "query"
	VALUE            = "value"
	SCORE            = "score"
)

type UserClient struct {
	db.ModelUserPlace
	ClientUID string `gorm:"type:char(32);index"`
}
type Client struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
	Host       string `gorm:"type:varchar(32)"`
	Port       string `gorm:"type:varchar(8)"`
	Username   string `gorm:"type:varchar(32)"`
	Password   string `gorm:"type:varchar(32)"`
	Database   string `gorm:"type:varchar(32)"`
}
type Summary struct {
	db.ModelContent
	ClientUID string  `gorm:"type:char(32);index"`
	Space     string  `gorm:"type:varchar(64)"`
	Index     string  `gorm:"type:varchar(128)"`
	Query     string  `gorm:"type:varchar(255)"`
	Field     string  `gorm:"type:varchar(255)"`
	Value     float32 `gorm:"default:0"`
	Score     float32 `gorm:"default:0"`
}

func init() { db.CmdModels("", &UserClient{}, &Client{}, &Summary{}) }
